git-stash.shon commit Merge branch 'jk/stash-loosen-safety' into maint (0752000)
   1#!/bin/sh
   2# Copyright (c) 2007, Nanako Shiraishi
   3
   4dashless=$(basename "$0" | sed -e 's/-/ /')
   5USAGE="list [<options>]
   6   or: $dashless show [<stash>]
   7   or: $dashless drop [-q|--quiet] [<stash>]
   8   or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
   9   or: $dashless branch <branchname> [<stash>]
  10   or: $dashless [save [--patch] [-k|--[no-]keep-index] [-q|--quiet] [<message>]]
  11   or: $dashless clear"
  12
  13SUBDIRECTORY_OK=Yes
  14OPTIONS_SPEC=
  15START_DIR=`pwd`
  16. git-sh-setup
  17require_work_tree
  18cd_to_toplevel
  19
  20TMP="$GIT_DIR/.git-stash.$$"
  21TMPindex=${GIT_INDEX_FILE-"$GIT_DIR/index"}.stash.$$
  22trap 'rm -f "$TMP-"* "$TMPindex"' 0
  23
  24ref_stash=refs/stash
  25
  26if git config --get-colorbool color.interactive; then
  27       help_color="$(git config --get-color color.interactive.help 'red bold')"
  28       reset_color="$(git config --get-color '' reset)"
  29else
  30       help_color=
  31       reset_color=
  32fi
  33
  34no_changes () {
  35        git diff-index --quiet --cached HEAD --ignore-submodules -- &&
  36        git diff-files --quiet --ignore-submodules
  37}
  38
  39clear_stash () {
  40        if test $# != 0
  41        then
  42                die "git stash clear with parameters is unimplemented"
  43        fi
  44        if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
  45        then
  46                git update-ref -d $ref_stash $current
  47        fi
  48}
  49
  50create_stash () {
  51        stash_msg="$1"
  52
  53        git update-index -q --refresh
  54        if no_changes
  55        then
  56                exit 0
  57        fi
  58
  59        # state of the base commit
  60        if b_commit=$(git rev-parse --verify HEAD)
  61        then
  62                head=$(git rev-list --oneline -n 1 HEAD --)
  63        else
  64                die "You do not have the initial commit yet"
  65        fi
  66
  67        if branch=$(git symbolic-ref -q HEAD)
  68        then
  69                branch=${branch#refs/heads/}
  70        else
  71                branch='(no branch)'
  72        fi
  73        msg=$(printf '%s: %s' "$branch" "$head")
  74
  75        # state of the index
  76        i_tree=$(git write-tree) &&
  77        i_commit=$(printf 'index on %s\n' "$msg" |
  78                git commit-tree $i_tree -p $b_commit) ||
  79                die "Cannot save the current index state"
  80
  81        if test -z "$patch_mode"
  82        then
  83
  84                # state of the working tree
  85                w_tree=$( (
  86                        git read-tree --index-output="$TMPindex" -m $i_tree &&
  87                        GIT_INDEX_FILE="$TMPindex" &&
  88                        export GIT_INDEX_FILE &&
  89                        git diff --name-only -z HEAD | git update-index -z --add --remove --stdin &&
  90                        git write-tree &&
  91                        rm -f "$TMPindex"
  92                ) ) ||
  93                        die "Cannot save the current worktree state"
  94
  95        else
  96
  97                rm -f "$TMP-index" &&
  98                GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
  99
 100                # find out what the user wants
 101                GIT_INDEX_FILE="$TMP-index" \
 102                        git add--interactive --patch=stash -- &&
 103
 104                # state of the working tree
 105                w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
 106                die "Cannot save the current worktree state"
 107
 108                git diff-tree -p HEAD $w_tree > "$TMP-patch" &&
 109                test -s "$TMP-patch" ||
 110                die "No changes selected"
 111
 112                rm -f "$TMP-index" ||
 113                die "Cannot remove temporary index (can't happen)"
 114
 115        fi
 116
 117        # create the stash
 118        if test -z "$stash_msg"
 119        then
 120                stash_msg=$(printf 'WIP on %s' "$msg")
 121        else
 122                stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
 123        fi
 124        w_commit=$(printf '%s\n' "$stash_msg" |
 125                git commit-tree $w_tree -p $b_commit -p $i_commit) ||
 126                die "Cannot record working tree state"
 127}
 128
 129save_stash () {
 130        keep_index=
 131        patch_mode=
 132        while test $# != 0
 133        do
 134                case "$1" in
 135                -k|--keep-index)
 136                        keep_index=t
 137                        ;;
 138                --no-keep-index)
 139                        keep_index=
 140                        ;;
 141                -p|--patch)
 142                        patch_mode=t
 143                        keep_index=t
 144                        ;;
 145                -q|--quiet)
 146                        GIT_QUIET=t
 147                        ;;
 148                --)
 149                        shift
 150                        break
 151                        ;;
 152                -*)
 153                        echo "error: unknown option for 'stash save': $1"
 154                        echo "       To provide a message, use git stash save -- '$1'"
 155                        usage
 156                        ;;
 157                *)
 158                        break
 159                        ;;
 160                esac
 161                shift
 162        done
 163
 164        stash_msg="$*"
 165
 166        git update-index -q --refresh
 167        if no_changes
 168        then
 169                say 'No local changes to save'
 170                exit 0
 171        fi
 172        test -f "$GIT_DIR/logs/$ref_stash" ||
 173                clear_stash || die "Cannot initialize stash"
 174
 175        create_stash "$stash_msg"
 176
 177        # Make sure the reflog for stash is kept.
 178        : >>"$GIT_DIR/logs/$ref_stash"
 179
 180        git update-ref -m "$stash_msg" $ref_stash $w_commit ||
 181                die "Cannot save the current status"
 182        say Saved working directory and index state "$stash_msg"
 183
 184        if test -z "$patch_mode"
 185        then
 186                git reset --hard ${GIT_QUIET:+-q}
 187
 188                if test -n "$keep_index" && test -n $i_tree
 189                then
 190                        git read-tree --reset -u $i_tree
 191                fi
 192        else
 193                git apply -R < "$TMP-patch" ||
 194                die "Cannot remove worktree changes"
 195
 196                if test -z "$keep_index"
 197                then
 198                        git reset
 199                fi
 200        fi
 201}
 202
 203have_stash () {
 204        git rev-parse --verify $ref_stash >/dev/null 2>&1
 205}
 206
 207list_stash () {
 208        have_stash || return 0
 209        git log --format="%gd: %gs" -g "$@" $ref_stash --
 210}
 211
 212show_stash () {
 213        assert_stash_like "$@"
 214
 215        git diff ${FLAGS:---stat} $b_commit $w_commit
 216}
 217
 218#
 219# Parses the remaining options looking for flags and
 220# at most one revision defaulting to ${ref_stash}@{0}
 221# if none found.
 222#
 223# Derives related tree and commit objects from the
 224# revision, if one is found.
 225#
 226# stash records the work tree, and is a merge between the
 227# base commit (first parent) and the index tree (second parent).
 228#
 229#   REV is set to the symbolic version of the specified stash-like commit
 230#   IS_STASH_LIKE is non-blank if ${REV} looks like a stash
 231#   IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
 232#   s is set to the SHA1 of the stash commit
 233#   w_commit is set to the commit containing the working tree
 234#   b_commit is set to the base commit
 235#   i_commit is set to the commit containing the index tree
 236#   w_tree is set to the working tree
 237#   b_tree is set to the base tree
 238#   i_tree is set to the index tree
 239#
 240#   GIT_QUIET is set to t if -q is specified
 241#   INDEX_OPTION is set to --index if --index is specified.
 242#   FLAGS is set to the remaining flags
 243#
 244# dies if:
 245#   * too many revisions specified
 246#   * no revision is specified and there is no stash stack
 247#   * a revision is specified which cannot be resolve to a SHA1
 248#   * a non-existent stash reference is specified
 249#
 250
 251parse_flags_and_rev()
 252{
 253        test "$PARSE_CACHE" = "$*" && return 0 # optimisation
 254        PARSE_CACHE="$*"
 255
 256        IS_STASH_LIKE=
 257        IS_STASH_REF=
 258        INDEX_OPTION=
 259        s=
 260        w_commit=
 261        b_commit=
 262        i_commit=
 263        w_tree=
 264        b_tree=
 265        i_tree=
 266
 267        REV=$(git rev-parse --no-flags --symbolic "$@" 2>/dev/null)
 268
 269        FLAGS=
 270        for opt
 271        do
 272                case "$opt" in
 273                        -q|--quiet)
 274                                GIT_QUIET=-t
 275                        ;;
 276                        --index)
 277                                INDEX_OPTION=--index
 278                        ;;
 279                        -*)
 280                                FLAGS="${FLAGS}${FLAGS:+ }$opt"
 281                        ;;
 282                esac
 283        done
 284
 285        set -- $REV
 286
 287        case $# in
 288                0)
 289                        have_stash || die "No stash found."
 290                        set -- ${ref_stash}@{0}
 291                ;;
 292                1)
 293                        :
 294                ;;
 295                *)
 296                        die "Too many revisions specified: $REV"
 297                ;;
 298        esac
 299
 300        REV=$(git rev-parse --quiet --symbolic --verify $1 2>/dev/null) || die "$1 is not valid reference"
 301
 302        i_commit=$(git rev-parse --quiet --verify $REV^2 2>/dev/null) &&
 303        set -- $(git rev-parse $REV $REV^1 $REV: $REV^1: $REV^2: 2>/dev/null) &&
 304        s=$1 &&
 305        w_commit=$1 &&
 306        b_commit=$2 &&
 307        w_tree=$3 &&
 308        b_tree=$4 &&
 309        i_tree=$5 &&
 310        IS_STASH_LIKE=t &&
 311        test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
 312        IS_STASH_REF=t
 313
 314        if test "${REV}" != "${REV%{*\}}"
 315        then
 316                # maintainers: it would be better if git rev-parse indicated
 317                # this condition with a non-zero status code but as of 1.7.2.1 it
 318                # it did not. So, we use non-empty stderr output as a proxy for the
 319                # condition of interest.
 320                test -z "$(git rev-parse "$REV" 2>&1 >/dev/null)" || die "$REV does not exist in the stash log"
 321        fi
 322
 323}
 324
 325is_stash_like()
 326{
 327        parse_flags_and_rev "$@"
 328        test -n "$IS_STASH_LIKE"
 329}
 330
 331assert_stash_like() {
 332        is_stash_like "$@" || die "'$*' is not a stash-like commit"
 333}
 334
 335is_stash_ref() {
 336        is_stash_like "$@" && test -n "$IS_STASH_REF"
 337}
 338
 339assert_stash_ref() {
 340        is_stash_ref "$@" || die "'$*' is not a stash reference"
 341}
 342
 343apply_stash () {
 344
 345        assert_stash_like "$@"
 346
 347        git update-index -q --refresh || die 'unable to refresh index'
 348
 349        # current index state
 350        c_tree=$(git write-tree) ||
 351                die 'Cannot apply a stash in the middle of a merge'
 352
 353        unstashed_index_tree=
 354        if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
 355                        test "$c_tree" != "$i_tree"
 356        then
 357                git diff-tree --binary $s^2^..$s^2 | git apply --cached
 358                test $? -ne 0 &&
 359                        die 'Conflicts in index. Try without --index.'
 360                unstashed_index_tree=$(git write-tree) ||
 361                        die 'Could not save index tree'
 362                git reset
 363        fi
 364
 365        eval "
 366                GITHEAD_$w_tree='Stashed changes' &&
 367                GITHEAD_$c_tree='Updated upstream' &&
 368                GITHEAD_$b_tree='Version stash was based on' &&
 369                export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
 370        "
 371
 372        if test -n "$GIT_QUIET"
 373        then
 374                GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
 375        fi
 376        if git merge-recursive $b_tree -- $c_tree $w_tree
 377        then
 378                # No conflict
 379                if test -n "$unstashed_index_tree"
 380                then
 381                        git read-tree "$unstashed_index_tree"
 382                else
 383                        a="$TMP-added" &&
 384                        git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
 385                        git read-tree --reset $c_tree &&
 386                        git update-index --add --stdin <"$a" ||
 387                                die "Cannot unstage modified files"
 388                        rm -f "$a"
 389                fi
 390                squelch=
 391                if test -n "$GIT_QUIET"
 392                then
 393                        squelch='>/dev/null 2>&1'
 394                fi
 395                (cd "$START_DIR" && eval "git status $squelch") || :
 396        else
 397                # Merge conflict; keep the exit status from merge-recursive
 398                status=$?
 399                if test -n "$INDEX_OPTION"
 400                then
 401                        echo >&2 'Index was not unstashed.'
 402                fi
 403                exit $status
 404        fi
 405}
 406
 407pop_stash() {
 408        assert_stash_ref "$@"
 409
 410        apply_stash "$@" &&
 411        drop_stash "$@"
 412}
 413
 414drop_stash () {
 415        assert_stash_ref "$@"
 416
 417        git reflog delete --updateref --rewrite "${REV}" &&
 418                say "Dropped ${REV} ($s)" || die "${REV}: Could not drop stash entry"
 419
 420        # clear_stash if we just dropped the last stash entry
 421        git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
 422}
 423
 424apply_to_branch () {
 425        test -n "$1" || die 'No branch name specified'
 426        branch=$1
 427        shift 1
 428
 429        set -- --index "$@"
 430        assert_stash_like "$@"
 431
 432        git checkout -b $branch $REV^ &&
 433        apply_stash "$@" && {
 434                test -z "$IS_STASH_REF" || drop_stash "$@"
 435        }
 436}
 437
 438PARSE_CACHE='--not-parsed'
 439# The default command is "save" if nothing but options are given
 440seen_non_option=
 441for opt
 442do
 443        case "$opt" in
 444        -*) ;;
 445        *) seen_non_option=t; break ;;
 446        esac
 447done
 448
 449test -n "$seen_non_option" || set "save" "$@"
 450
 451# Main command set
 452case "$1" in
 453list)
 454        shift
 455        list_stash "$@"
 456        ;;
 457show)
 458        shift
 459        show_stash "$@"
 460        ;;
 461save)
 462        shift
 463        save_stash "$@"
 464        ;;
 465apply)
 466        shift
 467        apply_stash "$@"
 468        ;;
 469clear)
 470        shift
 471        clear_stash "$@"
 472        ;;
 473create)
 474        if test $# -gt 0 && test "$1" = create
 475        then
 476                shift
 477        fi
 478        create_stash "$*" && echo "$w_commit"
 479        ;;
 480drop)
 481        shift
 482        drop_stash "$@"
 483        ;;
 484pop)
 485        shift
 486        pop_stash "$@"
 487        ;;
 488branch)
 489        shift
 490        apply_to_branch "$@"
 491        ;;
 492*)
 493        case $# in
 494        0)
 495                save_stash &&
 496                say '(To restore them type "git stash apply")'
 497                ;;
 498        *)
 499                usage
 500        esac
 501        ;;
 502esac